﻿using Ninject.Conditions;
using Ninject.Core;
using NinjectComplex.Drinks;
using NinjectComplex.Editors;
using NinjectComplex.Snacks;

namespace NinjectComplex.NinjectConfig
{
    internal class CustomModule : StandardModule
    {
        public override void Load()
        {
            Bind<ICaffeinated>().To<MountainDew>().Always();
            Bind<IEdible>().To<Cheetos>().Always();            
            Bind<ISugary>().To<Cookies>().Always();                        

            Bind<IEditor>().To<Emacs>()                
                .Only(When.Context.Member.DeclaringType == typeof(Programmer));

            //This is now in the Trunk
            //Bind<IEditor>().To<Emacs>().ForMembersOf<Programmer>();
                       
            Bind<IEditor>().To<VisualStudio>()
                .OnlyIf(c => c.Member.DeclaringType == typeof(MicrosoftProgrammer));
        }
    }
}