﻿using Moq;
using NinjectComplex;
using NUnit.Framework;

namespace NinjectComplexTest
{
    [TestFixture]
    public class ProgrammerFixture
    {
        [Test]
        public void WriteCodeTest()
        {
            var drink = new Mock<ICaffeinated>();
            var food = new Mock<IEdible>();
            var sweets = new Mock<ISugary>();
            var editor = new Mock<IEditor>();

            drink.Expect(d => d.Drink()).Returns("drinking a test!");
            food.Expect(f => f.Eat()).Returns("eating a test!");
            sweets.Expect(s => s.GetSugar()).Returns("sweeting a test!");
            editor.Expect(e => e.Program()).Returns("editing a test!");

            var programmer = new Programmer(drink.Object, food.Object, sweets.Object, editor.Object);
            programmer.WriteCode();

            drink.VerifyAll();
            food.VerifyAll();
            sweets.VerifyAll();
            editor.VerifyAll();
        }
    }
}