﻿using System;
using System.Threading;
using Ninject.Core;
using NinjectCreationBehaviors.Drinks;
using NinjectCreationBehaviors.NinjectConfig;

namespace NinjectCreationBehaviors
{
    internal class Program
    {
        private static void Main()
        {
            IKernel kernel = NinjectFactory.GetNinjectKernel();
            
            var drink1 = kernel.Get<ICaffeinated>();            
            Console.WriteLine(drink1.Drink());
            Console.WriteLine(drink1.DrinkCount);

            var callback = new WaitCallback(DrinkSomeCaffeine);
            var resetEvent = new ManualResetEvent(false);
            ThreadPool.QueueUserWorkItem(callback, resetEvent);
            resetEvent.WaitOne();

            var drink2 = kernel.Get<ICaffeinated>();
            Console.WriteLine(drink2.Drink());
            Console.WriteLine(drink2.DrinkCount);
        }

        private static void DrinkSomeCaffeine(Object state)
        {
            try
            {
                IKernel kernel = NinjectFactory.GetNinjectKernel();
                var drink = kernel.Get<ICaffeinated>();
                Console.WriteLine(drink.Drink());
                Console.WriteLine(drink.DrinkCount);
            }
            finally
            {
                ((ManualResetEvent) state).Set();
            }
        }
    }
}