﻿using Ninject.Conditions;
using Ninject.Core;
using Ninject.Core.Activation;
using NinjectFactoryConstruction.Drinks;
using NinjectFactoryConstruction.Editors;
using NinjectFactoryConstruction.Snacks;

namespace NinjectFactoryConstruction.NinjectConfig
{
    internal class CustomModule : StandardModule
    {
        public override void Load()
        {
            var drinkFactory = new DrinkFactory();                     
            Bind<ICaffeinated>()
                .ToFactoryMethod<ICaffeinated>(drinkFactory.GetMountainDew).Always();

            Bind<IEdible>().ToFactoryMethod<IEdible>(Cheetos.GetCheetos).Always();

            Bind<ISugary>().ToFactoryMethod<ISugary>(Cookies.GetCookies).Always();

            Bind<IEditor>().ToFactoryMethod<IEditor>(Emacs.GetEmacs)                
                .Only(When.Context.Member.DeclaringType == typeof(Programmer));
                       
            Bind<IEditor>().ToFactoryMethod<IEditor>(VisualStudio.GetVisualStudio)
                .OnlyIf(c => c.Member.DeclaringType == typeof(MicrosoftProgrammer));            
        }
    }
}