﻿using System;
using Ninject.Core;
using NinjectFactoryConstruction.NinjectConfig;

namespace NinjectFactoryConstruction
{
    public class Programmer
    {
        private readonly ICaffeinated drink;
        private readonly IEditor editor;
        private readonly IEdible food;
        private readonly ISugary sweets;

        protected Programmer(ICaffeinated drink, IEdible food, ISugary sweets, IEditor editor)
        {
            this.drink = drink;
            this.food = food;
            this.sweets = sweets;
            this.editor = editor;
        }

        public static Programmer GetProgrammer()
        {
            IKernel kernel = NinjectFactory.GetNinjectKernel();
            return kernel.Get<Programmer>();
        }

        public void WriteCode()
        {
            Console.WriteLine(drink.Drink());
            Console.WriteLine(food.Eat());
            Console.WriteLine(sweets.GetSugar());
            Console.WriteLine(editor.Program());
        }               
    }
}