﻿using System;
using Ninject.Core;

namespace NinjectMethodInjection
{
    public class Programmer
    {        
        public ICaffeinated Drink { get; set; }
        public IEdible Food { get; set; }        
        public ISugary Sweets { get; set; }        
        public IEditor Editor { get; set; }

        public Programmer()
        {
        }
        
        [Inject]
        public void InjectCaffeineAndSweets(ICaffeinated drink, ISugary sweets)
        {
            Drink = drink;
            Sweets = sweets;
        }

        [Inject]
        public void InjectFoodAndEditor(IEdible food, IEditor editor)
        {
            Food = food;
            Editor = editor;
        }                

        public void WriteCode()
        {
            Console.WriteLine(Drink.Drink());
            Console.WriteLine(Food.Eat());
            Console.WriteLine(Sweets.GetSugar());
            Console.WriteLine(Editor.Program());
        }
    }
}