﻿using Ninject.Conditions;
using Ninject.Core;
using NinjectPropertyInjection.Drinks;
using NinjectPropertyInjection.Editors;
using NinjectPropertyInjection.Snacks;

namespace NinjectPropertyInjection.NinjectConfig
{
    internal class CustomModule : StandardModule
    {
        public override void Load()
        {
            Bind<ICaffeinated>().To<MountainDew>().Always();
            Bind<IEdible>().To<Cheetos>().Always();            
            Bind<ISugary>().To<Cookies>().Always();

            Bind<IEditor>().To<Emacs>()
                .OnlyIf(c => c.Member.ReflectedType == typeof (Programmer));                                   

            Bind<IEditor>().To<VisualStudio>()
                .OnlyIf(c => c.Member.ReflectedType == typeof (MicrosoftProgrammer));
        }
    }
}