﻿using System;
using Spring.Context;
using Spring.Context.Support;

namespace SpringFactoryConstruction
{
    public class Programmer
    {
        private readonly ICaffeinated drink;
        private readonly IEditor editor;
        private readonly IEdible food;
        private readonly ISugary sweets;

        protected Programmer(ICaffeinated drink, IEdible food, ISugary sweets, IEditor editor)
        {
            this.drink = drink;
            this.food = food;
            this.sweets = sweets;
            this.editor = editor;
        }

        public static Programmer GetProgrammer()
        {
            IApplicationContext context = ContextRegistry.GetContext();
            return (Programmer)context.GetObject("Programmer");            
        }

        public void WriteCode()
        {
            Console.WriteLine(drink.Drink());
            Console.WriteLine(food.Eat());
            Console.WriteLine(sweets.GetSugar());
            Console.WriteLine(editor.Program());
        }               
    }
}