﻿using System;
using System.Threading;
using Spring.Context;
using Spring.Context.Support;

namespace SpringSingleton
{
    internal class Program
    {       
        private static void Main()
        {
            IApplicationContext context = ContextRegistry.GetContext();

            var drink1 = (ICaffeinated)context.GetObject("MountainDew");
            Console.WriteLine(drink1.Drink());
            Console.WriteLine(drink1.DrinkCount);

            var callback = new WaitCallback(DrinkSomeCaffeine);
            var resetEvent = new ManualResetEvent(false);
            ThreadPool.QueueUserWorkItem(callback, resetEvent);
            resetEvent.WaitOne();

            var drink2 = (ICaffeinated)context.GetObject("MountainDew");
            Console.WriteLine(drink2.Drink());
            Console.WriteLine(drink2.DrinkCount);
        }

        private static void DrinkSomeCaffeine(Object state)
        {
            try
            {
                IApplicationContext context = ContextRegistry.GetContext();
                var drink = (ICaffeinated)context.GetObject("MountainDew");
                Console.WriteLine(drink.Drink());
                Console.WriteLine(drink.DrinkCount);
            }
            finally
            {
                ((ManualResetEvent)state).Set();
            }
        }
    }
}